/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.op.C_cond;
import ru.ispras.microtesk.model.IsaPrimitive;
import ru.ispras.microtesk.model.Immediate;
import ru.ispras.microtesk.model.mips64.mode.FR;

/**
 * The {@code DecoderC_cond} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderC_cond extends DecoderItem {
  private static DecoderC_cond instance = null;

  public static DecoderC_cond get() {
    if (null == instance) {
      instance = new DecoderC_cond();
    }
    return instance;
  }

  private DecoderC_cond() {
    super(
        32,
        true,
        "01000100000000000000000000110000",
        "11111100000000000000000011110000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    IsaPrimitive cond_value = null;
    IsaPrimitive op_fmt = null;
    Immediate cc = null;
    FR fs = null;
    FR ft = null;

    if (!matchNextOpc(image, BitVector.valueOf("010001", 2, 6))) {
      return null;
    }

    op_fmt = (IsaPrimitive) readNextPrimitive(image, DecoderFMT_FORMAT.get());
    if (null == op_fmt) {
      return null;
    }

    ft = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == ft) {
      return null;
    }

    fs = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == fs) {
      return null;
    }

    cc = readNextImmediate(image, Type.CARD(3));

    if (!matchNextOpc(image, BitVector.valueOf("0011", 2, 4))) {
      return null;
    }

    cond_value = (IsaPrimitive) readNextPrimitive(image, DecoderFPU_COND_TYPE.get());
    if (null == cond_value) {
      return null;
    }

    return newResult(new C_cond(cond_value, op_fmt, cc, fs, ft));
  }
}
