/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.op.clz;
import ru.ispras.microtesk.model.mips64.mode.R;

/**
 * The {@code DecoderClz} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderClz extends DecoderItem {
  private static DecoderClz instance = null;

  public static DecoderClz get() {
    if (null == instance) {
      instance = new DecoderClz();
    }
    return instance;
  }

  private DecoderClz() {
    super(
        32,
        true,
        "01110000000000000000000000100000",
        "11111100000000000000011111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    R rd = null;
    R rs = null;

    if (!matchNextOpc(image, BitVector.valueOf("011100", 2, 6))) {
      return null;
    }

    rs = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rs) {
      return null;
    }

    rd = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rd) {
      return null;
    }

    rd = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rd) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("00000100000", 2, 11))) {
      return null;
    }

    return newResult(new clz(rd, rs));
  }
}
