/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.op.wsbh;
import ru.ispras.microtesk.model.mips64.mode.R;

/**
 * The {@code DecoderWsbh} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderWsbh extends DecoderItem {
  private static DecoderWsbh instance = null;

  public static DecoderWsbh get() {
    if (null == instance) {
      instance = new DecoderWsbh();
    }
    return instance;
  }

  private DecoderWsbh() {
    super(
        32,
        true,
        "01111100000000000000000010000000",
        "11111111111000000000011111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    R rd = null;
    R rt = null;

    if (!matchNextOpc(image, BitVector.valueOf("01111100000", 2, 11))) {
      return null;
    }

    rt = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rt) {
      return null;
    }

    rd = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rd) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("00010000000", 2, 11))) {
      return null;
    }

    return newResult(new wsbh(rd, rt));
  }
}
