/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.mmu.sim;

import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.mmu.model.api.*;
import ru.ispras.fortress.data.types.bitvector.*;

/**
 * The {@code KSEG0} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class KSEG0 extends Segment<PA, VA> {
  private static KSEG0 instance = null;

  public static KSEG0 get() {
    if (null == instance) {
      instance = new KSEG0();
    }
    return instance;
  }

  private KSEG0() {
    super(
        BitVector.valueOf(0xFFFFFFFF80000000L, 64),
        BitVector.valueOf(0xFFFFFFFF9FFFFFFFL, 64)
    );
  }

  @Override
  public PA getData(final VA va) {
    final PA pa = new PA();

    final BitVector zero = BitVector.newEmpty(7);

    zero.assign(BitVector.valueOf(0x00, 7));
    pa.value.assign(BitVector.newMapping(va.value.field(28, 0), zero));
    pa.cca.assign(Extern.get().K0());

    return pa;
  }
}
