/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.mmu.sim;

import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.mmu.model.api.*;
import ru.ispras.fortress.data.types.bitvector.*;

/**
 * The {@code USEG} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class USEG extends Segment<PA, VA> {
  private static USEG instance = null;

  public static USEG get() {
    if (null == instance) {
      instance = new USEG();
    }
    return instance;
  }

  private USEG() {
    super(
        BitVector.valueOf(0x0000000000000000L, 64),
        BitVector.valueOf(0x000000007FFFFFFFL, 64)
    );
  }

  @Override
  public PA getData(final VA va) {
    final PA pa = new PA();

    final JTLB.Entry tlbEntry = new JTLB.Entry();
    final BitVector g = BitVector.newEmpty(1);
    final BitVector v = BitVector.newEmpty(1);
    final BitVector d = BitVector.newEmpty(1);
    final BitVector c = BitVector.newEmpty(3);
    final BitVector pfn = BitVector.newEmpty(24);

    if (DTLB.get().isHit(va)) {
      tlbEntry.assign(DTLB.get().getData(va));
    } else if (JTLB.get().isHit(va)) {
      tlbEntry.assign(JTLB.get().getData(va));
    } else {
      Execution.exception("TLBMiss");
    }
    if (va.value.field(12, 12).equals(BitVector.valueOf(0x00, 1))) {
      g.assign(tlbEntry.G0);
      v.assign(tlbEntry.V0);
      d.assign(tlbEntry.D0);
      c.assign(tlbEntry.C0);
      pfn.assign(tlbEntry.PFN0);
    } else {
      g.assign(tlbEntry.G1);
      v.assign(tlbEntry.V1);
      d.assign(tlbEntry.D1);
      c.assign(tlbEntry.C1);
      pfn.assign(tlbEntry.PFN1);
    }
    if (v.equals(BitVector.valueOf(0x01, 1))) {
      pa.value.assign(BitVector.newMapping(va.value.field(11, 0), pfn.field(23, 0)));
      pa.cca.assign(c);
    } else {
      Execution.exception("TLBInvalid");
    }
    DTLB.get().setData(va).assign(tlbEntry);

    return pa;
  }
}
