/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.mmu.spec;

import java.util.Collections;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.microtesk.basis.solver.integer.IntegerVariable;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBinding;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBuffer;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuExpression;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuStruct;

/**
 * The {@code JTLB} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class JTLB extends MmuBuffer {
  private static JTLB INSTANCE = null;

  public static JTLB get() {
    if (null == INSTANCE) {
      INSTANCE = new JTLB();
    }
    return INSTANCE;
  }

  private final VA va = VA.get();

  public static final class Entry extends MmuStruct {
    public final IntegerVariable R;
    public final IntegerVariable FILL_;
    public final IntegerVariable VPN2;
    public final IntegerVariable ZERO_;
    public final IntegerVariable ASID;
    public final IntegerVariable R0_;
    public final IntegerVariable PFN0;
    public final IntegerVariable C0;
    public final IntegerVariable D0;
    public final IntegerVariable V0;
    public final IntegerVariable G0;
    public final IntegerVariable R1_;
    public final IntegerVariable PFN1;
    public final IntegerVariable C1;
    public final IntegerVariable D1;
    public final IntegerVariable V1;
    public final IntegerVariable G1;

    public Entry(final String name) {
      super(name);

      this.R = new IntegerVariable(name + ".R", 2);
      this.FILL_ = new IntegerVariable(name + ".FILL_", 22);
      this.VPN2 = new IntegerVariable(name + ".VPN2", 27);
      this.ZERO_ = new IntegerVariable(name + ".ZERO_", 5);
      this.ASID = new IntegerVariable(name + ".ASID", 8);
      this.R0_ = new IntegerVariable(name + ".R0_", 2);
      this.PFN0 = new IntegerVariable(name + ".PFN0", 24);
      this.C0 = new IntegerVariable(name + ".C0", 3);
      this.D0 = new IntegerVariable(name + ".D0", 1);
      this.V0 = new IntegerVariable(name + ".V0", 1);
      this.G0 = new IntegerVariable(name + ".G0", 1);
      this.R1_ = new IntegerVariable(name + ".R1_", 2);
      this.PFN1 = new IntegerVariable(name + ".PFN1", 24);
      this.C1 = new IntegerVariable(name + ".C1", 3);
      this.D1 = new IntegerVariable(name + ".D1", 1);
      this.V1 = new IntegerVariable(name + ".V1", 1);
      this.G1 = new IntegerVariable(name + ".G1", 1);

      addField(R);
      addField(FILL_);
      addField(VPN2);
      addField(ZERO_);
      addField(ASID);
      addField(R0_);
      addField(PFN0);
      addField(C0);
      addField(D0);
      addField(V0);
      addField(G0);
      addField(R1_);
      addField(PFN1);
      addField(C1);
      addField(D1);
      addField(V1);
      addField(G1);
    }
  }
  public final IntegerVariable R;
  public final IntegerVariable FILL_;
  public final IntegerVariable VPN2;
  public final IntegerVariable ZERO_;
  public final IntegerVariable ASID;
  public final IntegerVariable R0_;
  public final IntegerVariable PFN0;
  public final IntegerVariable C0;
  public final IntegerVariable D0;
  public final IntegerVariable V0;
  public final IntegerVariable G0;
  public final IntegerVariable R1_;
  public final IntegerVariable PFN1;
  public final IntegerVariable C1;
  public final IntegerVariable D1;
  public final IntegerVariable V1;
  public final IntegerVariable G1;

  private JTLB() {
    this("JTLB");
  }

  private JTLB(final String name) {
    super(
        name,
        Kind.REGISTER,
        64L,
        1L,
        VA.get(),
        MmuExpression.var(VA.get().value, 13, 39),
        MmuExpression.empty(),
        MmuExpression.rcat(VA.get().value.field(0, 12), VA.get().value.field(40, 63)),
        Collections.<MmuBinding>emptyList(), // set up with setMatchBindings
        false,
        null
    );

    this.R = new IntegerVariable(name + ".R", 2);
    this.FILL_ = new IntegerVariable(name + ".FILL_", 22);
    this.VPN2 = new IntegerVariable(name + ".VPN2", 27);
    this.ZERO_ = new IntegerVariable(name + ".ZERO_", 5);
    this.ASID = new IntegerVariable(name + ".ASID", 8);
    this.R0_ = new IntegerVariable(name + ".R0_", 2);
    this.PFN0 = new IntegerVariable(name + ".PFN0", 24);
    this.C0 = new IntegerVariable(name + ".C0", 3);
    this.D0 = new IntegerVariable(name + ".D0", 1);
    this.V0 = new IntegerVariable(name + ".V0", 1);
    this.G0 = new IntegerVariable(name + ".G0", 1);
    this.R1_ = new IntegerVariable(name + ".R1_", 2);
    this.PFN1 = new IntegerVariable(name + ".PFN1", 24);
    this.C1 = new IntegerVariable(name + ".C1", 3);
    this.D1 = new IntegerVariable(name + ".D1", 1);
    this.V1 = new IntegerVariable(name + ".V1", 1);
    this.G1 = new IntegerVariable(name + ".G1", 1);

    addField(R);
    addField(FILL_);
    addField(VPN2);
    addField(ZERO_);
    addField(ASID);
    addField(R0_);
    addField(PFN0);
    addField(C0);
    addField(D0);
    addField(V0);
    addField(G0);
    addField(R1_);
    addField(PFN1);
    addField(C1);
    addField(D1);
    addField(V1);
    addField(G1);

    setMatchBindings(Arrays.<MmuBinding>asList(
        new MmuBinding(VPN2, VA.get().value.field(13, 39))));
  }
}
