/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.mmu.spec;

import ru.ispras.microtesk.basis.solver.integer.IntegerVariable;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuExpression;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuSubsystem;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.microtesk.mmu.basis.BufferAccessEvent;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuAction;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBinding;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBufferAccess;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuCondition;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuConditionAtom;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuExpression;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuGuard;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuSegment;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuTransition;
import java.util.ArrayList;
import java.util.List;

/**
 * The {@code putWordIntoLine} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class putWordIntoLine {
  private static putWordIntoLine INSTANCE = null;

  public static putWordIntoLine get() {
    if (null == INSTANCE) {
      INSTANCE = new putWordIntoLine();
    }
    return INSTANCE;
  }

  private int callIndex = 0;

  public final Function newCall(
      final MmuSubsystem.Builder builder,
      final IntegerVariable putWordIntoLine,
      final IntegerVariable wordIndex,
      final IntegerVariable line,
      final IntegerVariable data) {
    return new Function(builder, callIndex++, putWordIntoLine, wordIndex, line, data);
  }

  public static final class Function {
    public final IntegerVariable putWordIntoLine;
    public final IntegerVariable wordIndex;
    public final IntegerVariable line;
    public final IntegerVariable data;

    private final IntegerVariable intline;


    public final MmuAction START;
    public final MmuAction STOP;

    private final MmuAction ASSIGN_0;
    private final MmuAction BRANCH_0;
    private final MmuAction ASSIGN_1;
    private final MmuAction JOIN_0;
    private final MmuAction BRANCH_1;
    private final MmuAction ASSIGN_2;
    private final MmuAction BRANCH_2;
    private final MmuAction ASSIGN_3;
    private final MmuAction BRANCH_3;
    private final MmuAction ASSIGN_4;
    private final MmuAction ASSIGN_5;

    private Function(
        final MmuSubsystem.Builder builder,
        final int instanceIndex,
        final IntegerVariable putWordIntoLine,
        final IntegerVariable wordIndex,
        final IntegerVariable line,
        final IntegerVariable data) {
      final String name = String.format("putWordIntoLine_%d", instanceIndex);
      this.putWordIntoLine = putWordIntoLine; 
      this.wordIndex = wordIndex; 
      this.line = line; 
      this.data = data; 

      this.intline = new IntegerVariable(name + ".intline", 256);
      builder.registerVariable(intline);

      this.START = new MmuAction(name + ".START");
      builder.registerAction(START);
      this.STOP = new MmuAction(name + ".STOP");
      builder.registerAction(STOP);

      this.ASSIGN_0 = new MmuAction(name + ".ASSIGN_0", new MmuBinding(intline, line));
      builder.registerAction(ASSIGN_0);
      builder.registerTransition(new MmuTransition(START, ASSIGN_0));
      this.BRANCH_0 = new MmuAction(name + ".BRANCH_0");
      builder.registerAction(BRANCH_0);
      builder.registerTransition(new MmuTransition(ASSIGN_0, BRANCH_0, new MmuGuard(MmuConditionAtom.eq(wordIndex, new BigInteger("0", 10)))));
      this.ASSIGN_1 = new MmuAction(name + ".ASSIGN_1", new MmuBinding(intline.field(0, 63), data));
      builder.registerAction(ASSIGN_1);
      builder.registerTransition(new MmuTransition(BRANCH_0, ASSIGN_1));
      this.JOIN_0 = new MmuAction(name + ".JOIN_0");
      builder.registerAction(JOIN_0);
      builder.registerTransition(new MmuTransition(ASSIGN_1, JOIN_0));
      this.BRANCH_1 = new MmuAction(name + ".BRANCH_1");
      builder.registerAction(BRANCH_1);
      builder.registerTransition(new MmuTransition(ASSIGN_0, BRANCH_1, new MmuGuard(MmuConditionAtom.eq(wordIndex, new BigInteger("1", 10)))));
      this.ASSIGN_2 = new MmuAction(name + ".ASSIGN_2", new MmuBinding(intline.field(64, 127), data));
      builder.registerAction(ASSIGN_2);
      builder.registerTransition(new MmuTransition(BRANCH_1, ASSIGN_2));
      builder.registerTransition(new MmuTransition(ASSIGN_2, JOIN_0));
      this.BRANCH_2 = new MmuAction(name + ".BRANCH_2");
      builder.registerAction(BRANCH_2);
      builder.registerTransition(new MmuTransition(ASSIGN_0, BRANCH_2, new MmuGuard(MmuConditionAtom.eq(wordIndex, new BigInteger("2", 10)))));
      this.ASSIGN_3 = new MmuAction(name + ".ASSIGN_3", new MmuBinding(intline.field(128, 191), data));
      builder.registerAction(ASSIGN_3);
      builder.registerTransition(new MmuTransition(BRANCH_2, ASSIGN_3));
      builder.registerTransition(new MmuTransition(ASSIGN_3, JOIN_0));
      this.BRANCH_3 = new MmuAction(name + ".BRANCH_3");
      builder.registerAction(BRANCH_3);
      builder.registerTransition(new MmuTransition(ASSIGN_0, BRANCH_3, new MmuGuard(MmuCondition.and(MmuConditionAtom.neq(wordIndex, new BigInteger("0", 10)), MmuConditionAtom.neq(wordIndex, new BigInteger("1", 10)), MmuConditionAtom.neq(wordIndex, new BigInteger("2", 10))))));
      this.ASSIGN_4 = new MmuAction(name + ".ASSIGN_4", new MmuBinding(intline.field(192, 255), data));
      builder.registerAction(ASSIGN_4);
      builder.registerTransition(new MmuTransition(BRANCH_3, ASSIGN_4));
      builder.registerTransition(new MmuTransition(ASSIGN_4, JOIN_0));
      this.ASSIGN_5 = new MmuAction(name + ".ASSIGN_5", new MmuBinding(putWordIntoLine, intline));
      builder.registerAction(ASSIGN_5);
      builder.registerTransition(new MmuTransition(JOIN_0, ASSIGN_5));
      builder.registerTransition(new MmuTransition(ASSIGN_5, STOP));
    }
  }
}
