/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class check_sign_extend_values extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "check_sign_extend_values",
          check_sign_extend_values.class,
          null
          );
      addArgument("rs", R.INFO);
      addArgument("rt", R.INFO);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rs = (R) getArgument("rs", args);
      final R rt = (R) getArgument("rt", args);

      return new check_sign_extend_values(rs, rt);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rs;
  public final R rt;

  public check_sign_extend_values(final R rs, final R rt) {
    assert R.INFO.isSupported(rs);
    assert R.INFO.isSupported(rt);

    this.rs = rs;
    this.rt = rt;

    addArgument("rs", rs);
    addArgument("rt", rt);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    if ((!Data.signExtend(WORD, rs.access(pe__, vars__).bitField(31, 31).load()).equals(rs.access(pe__, vars__).bitField(63, 32).load()) || !Data.signExtend(WORD, rt.access(pe__, vars__).bitField(31, 31).load()).equals(rt.access(pe__, vars__).bitField(63, 32).load()))) {
      Execution.unpredicted();
    }
  }
}