/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class reverse_bits_in_byte extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "reverse_bits_in_byte",
          reverse_bits_in_byte.class,
          null
          );
      addArgument("input_byte_value", BYTE);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate input_byte_value = (Immediate) getArgument("input_byte_value", args);

      return new reverse_bits_in_byte(input_byte_value);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate input_byte_value;

  public reverse_bits_in_byte(final Immediate input_byte_value) {
    assert BYTE.equals(input_byte_value.getType());

    this.input_byte_value = input_byte_value;

    addArgument("input_byte_value", input_byte_value);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.temp_reverse.access().bitField(0, 0).store(input_byte_value.access().bitField(7, 7).load());
    vars__.temp_reverse.access().bitField(1, 1).store(input_byte_value.access().bitField(6, 6).load());
    vars__.temp_reverse.access().bitField(2, 2).store(input_byte_value.access().bitField(5, 5).load());
    vars__.temp_reverse.access().bitField(3, 3).store(input_byte_value.access().bitField(4, 4).load());
    vars__.temp_reverse.access().bitField(4, 4).store(input_byte_value.access().bitField(3, 3).load());
    vars__.temp_reverse.access().bitField(5, 5).store(input_byte_value.access().bitField(2, 2).load());
    vars__.temp_reverse.access().bitField(6, 6).store(input_byte_value.access().bitField(1, 1).load());
    vars__.temp_reverse.access().bitField(7, 7).store(input_byte_value.access().bitField(0, 0).load());
  }
}