/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.decoder;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.vliw.op.B;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderB} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderB extends DecoderItem {
  private static DecoderB instance = null;

  public static DecoderB get() {
    if (null == instance) {
      instance = new DecoderB();
    }
    return instance;
  }

  private DecoderB() {
    super(
        32,
        true,
        "00010000000000000000000000000000",
        "11111111111111110000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    Immediate offset = null;

    if (!matchNextOpc(image, BitVector.valueOf("0001000000000000", 2, 16))) {
      return null;
    }

    offset = readNextImmediate(image, SHORT);

    return newResult(new B(offset));
  }
}
