/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.decoder;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.vliw.op.LW;
import ru.ispras.microtesk.model.vliw.mode.R;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderLW} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderLW extends DecoderItem {
  private static DecoderLW instance = null;

  public static DecoderLW get() {
    if (null == instance) {
      instance = new DecoderLW();
    }
    return instance;
  }

  private DecoderLW() {
    super(
        32,
        true,
        "10001100000000000000000000000000",
        "11111100000000000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    R base = null;
    R rt = null;
    Immediate offset = null;

    if (!matchNextOpc(image, BitVector.valueOf("100011", 2, 6))) {
      return null;
    }

    base = (R) readNextPrimitive(image, DecoderR.get());
    if (null == base) {
      return null;
    }

    rt = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rt) {
      return null;
    }

    offset = readNextImmediate(image, SHORT);

    return newResult(new LW(base, rt, offset));
  }
}
